if(panning,
  A.x=A.x+0.01*(mouse().x-start.x);
	//start=mouse().xy;
);

center=(18,0);
k(x):=parse(Text0.val);
f(x):=k(x);
g(x):=(f((x-center.x)/bsiz*siz+A.x)-A.y)/siz*bsiz+center.y;

tr(p):=(p-A)/siz*bsiz+center;


A.y=f(A.x);

siz=2*|B,D|/|B,C|+.01;
bsiz=8;

Al=(A.x-siz,f(A.x-siz));
Ar=(A.x+siz,f(A.x+siz));

left=tr(Al);
right=tr(Ar);



secants=Text1.pressed;
triangles=Text2.pressed;
transfer=false;

steigung=Text1.pressed % Text2.pressed;
steigungsdreieck=false;


//Achsen

draw((0,-20),(0,20),color->(1,1,1)*.3,size->2);
draw((-20,0),(20,0),color->(1,1,1)*.3,size->2);
apply(-10..10,i=#*2;
  draw((i,-.2),(i,.2),color->(1,1,1)*.3,size->2);
  draw((-.2,i),(.2,i),color->(1,1,1)*.3,size->2);
);







lupe=[
   A+(siz,siz),
   A+(-siz,siz),
   A+(-siz,-siz),
   A+(siz,-siz)
];


//Lupe malen
fillpoly(lupe,color->(1,1,1)*1,alpha->0.5);
drawpoly(lupe,color->(0,0,0),color->(.4,0,0));

//Funktion
plot(f(x),color->(0,0,0.8),size->2);

//Kasten um große Lupe

box=[
   center+(bsiz,bsiz),
   center+(-bsiz,bsiz),
   center+(-bsiz,-bsiz),
   center+(bsiz,-bsiz)
];

box2=[
   center+(bsiz,bsiz)*1.03,
   center+(-bsiz,bsiz)*1.03,
   center+(-bsiz,-bsiz)*1.03,
   center+(bsiz,-bsiz)*1.03
];

//Sekanten Malen im Hauptbild

if(secants,
 draw(join(Ar,A),color->red(.8),size->2,dashing->5);
 draw(join(Al,A),color->green(.4),size->2,dashing->5);
);


gsave();

fillpoly(box2,color->(1,1,1)*.85);
drawpoly(box,color->(.4,0,0),size->2);
clip(box);


//Gitter in der Lupe
snap=0.1/64;
repeat(18,i=2^#;
  if(siz<7/i,snap=.8/i);
);


min=A.xy-(siz,siz);
max=A.xy+(siz,siz);
smin=floor(min/snap)*snap;
smax=ceil(max/snap)*snap;

repeat(1,start->smin.x,stop->smax.x,step->snap,
  draw(tr((#,smin.y)),tr((#,smax.y)),color->gray(0.7));
);

repeat(1,start->smin.y,stop->smax.y,step->snap,
  draw(tr((smin.x,#)),tr((smax.x,#)),color->gray(0.7));
);


//Funktion in Lupe

plot(g(x),   
        start-> center.x-bsiz,
        stop->center.x+bsiz,
        color->(0,0,0.8),size->2);


//Bigtriangles

if(triangles,
  fillpoly([left,center,(center.x-bsiz,0)],color->blue(0.7),alpha->.3);
  fillpoly([right,center,(center.x+bsiz,0)],color->blue(0.7),alpha->.3);
);


//Secanten in Lupe
if(secants,
 draw(join(left,center),color->red(.8),size->2,dashing->5);
 draw(join(right,center),color->green(.4),size->2,dashing->5);
);


//Steigungstreieck


if(steigungsdreieck,
  tri1=(Al,Al+(1,0),Al+(1,(A.y-Al.y)/(A.x-Al.x)));
  tri1=apply(tri1,tr(#));
  fillpoly(tri1,color->(1,1,1),alpha->0.8);
  drawpoly(tri1,color->(1,1,1)*.2,alpha->0.8);
  drawtext((tri1_1+tri1_2)/2+(0,-.6),1);

  tri2=(A,A+(1,0),A+(1,(A.y-Ar.y)/(A.x-Ar.x)));
  tri2=apply(tri2,tr(#));
  fillpoly(tri2,color->(1,1,1),alpha->0.8);
  drawpoly(tri2,color->(1,1,1)*.2,alpha->0.8);
  drawtext((tri2_1+tri2_2)/2+(0,-.6),1);

);




//Steigungstext

if(steigung,
 drawtext((10.2,-6.2),"linksseitige 
Sekantensteigung="+g(center.x-bsiz)/(-bsiz),size->16);
 drawtext((18.9,-6.2),"rechtsseitige 
Sekantensteigung="+g(center.x+bsiz)/(bsiz),size->16);
);







grestore();

//Steigunsfunktionen

if(transfer,

  draw((A.x,g(center.x-bsiz)/(-bsiz)),color->red(.7));
  draw(Pr=(A.x,g(center.x+bsiz)/(+bsiz)),color->green(.4));

  plot((f(x)-f(x-siz))/(siz),color->red(.7),alpha->.6);
  plot((f(x)-f(x+siz))/(-siz),color->green(.4),alpha->.6);

);


//General
draw(center,color->(0,1,0));
drawtext(center+(0.2,0.2),"A",size->24);



drawtext((1.2,8.8),"h="+siz,size->16);


draw(Ar,color->(1,0,0));
drawtext(Ar+(.2,.2),"$A_r$");

draw(Al,color->(1,0,0));
drawtext(Al+(-.5,.2),"$A_l$");


draw(tr(Ar),color->(1,0,0));
drawtext(tr(Ar)+(.2,.2),"$A_r$");

draw(tr(Al),color->(1,0,0));
drawtext(tr(Al)+(-.5,.2),"$A_l$");
connect(box++[box_1],color->(.4,0,0),size->2.5);

